%define ALD_Ver		2.0

#USE gcc-7.5.0

%define OrgName busybox
%define mC_Version 1.2.4s

Name:         mC-%{OrgName}
License:      GPL
Summary:      BusyBox build static
Version:      1.36.1
Release:      %{mC_Version}.0

#Source: https://busybox.net/downloads/

Source: %{OrgName}-%{version}.tar.xz
Source2: %{OrgName}-%{version}-patches.tgz

%define DestDir		/Embedded/uC-%{version}

%define DestDir /Embedded/mC/%{mC_Version}
%define _prefix /usr/mC/%{mC_Version}
%define _bindir /bin
%define _datadir /usr/share

# -----------------------------------------------------
%define auto_local %{_sourcedir}/AUTO_LOCAL-1.sh
%define have_auto_local %(if test -x %{auto_local} ; then echo 1 ; else echo 0 ; fi)

%if %{_target_cpu} == %{_build_cpu}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}/mC/%{mC_Version}
%define _CROSS 0
%define MakeLocCross 0
%else
# rpm --target=x86_64 -ba xxxxx.spec
%define _srcrpmdir	%{_topdir}/SRPMS/tmp
%define _CROSS 1
%define MakeLocCross 1
%endif

# -----------------------------------------------------

%if %{have_auto_local}
%define __os_install_post %{nil}
%else
%define MakeLocCross 0
%endif

%if %{_CROSS}
%define CrossPath /cross/%{_target_cpu}
%else
%define CrossPath %{nil}
%endif

#------------------ CROSS DIR --------------------

%define target %{_arch}-linux-musl
%define docdir %{_defaultdocdir}/%{OrgName}

# ------------------- description ------------------------------------
%description
Busybox is a single binary which includes versions of a large number
of system commands, including a shell.  This package can be very
useful for recovering from certain types of system failures,
particularly those involving broken shared libraries.
# --------------------------------------
%package env
Summary:      BusyBox env
Provides:     env
%description env
BusyBox env
# --------------------------------------
%package doc
Summary:      doc for %{OrgName}
Group:        Documentation
%description doc
doc for %{OrgName}

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{OrgName}-%{version}

tar -xzf %SOURCE2
#patch -p0<patches/musl.patch

# ------------------- Build ------------------------------------------
%Build
export PATH=$PATH:%{CrossPath}%{_prefix}/bin
export GCC_NoHostPath=d

cp patches/.config_tools .config

export CROSS_COMPILE=%{target}-

make V=1 &>FMake_log.txt

# ------------------- Install ----------------------------------------
%Install
export PATH=$PATH:%{CrossPath}%{_prefix}/bin
export GCC_NoHostPath=d


rm -rf $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT/%{_bindir}
mkdir -p $RPM_BUILD_ROOT/usr/%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{docdir}/html

cp busybox $RPM_BUILD_ROOT/%{_bindir}/
cp -a docs/busybox.net/* $RPM_BUILD_ROOT%{docdir}/html
cp -a AUTHORS LICENSE README $RPM_BUILD_ROOT%{docdir}/

mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}
cp examples/udhcp/udhcpd.conf $RPM_BUILD_ROOT/%{_sysconfdir}/
mkdir -p $RPM_BUILD_ROOT%{_datadir}/udhcpc 
cp -a examples/udhcp/simple.script $RPM_BUILD_ROOT%{_datadir}/udhcpc/default.script
cp -a patches/default6.script $RPM_BUILD_ROOT%{_datadir}/udhcpc/

pushd $RPM_BUILD_ROOT/usr%{_bindir}
ln -s /bin/busybox env
popd

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} -target_platform=%{target}-
%endif  # have_auto_local

# ------------------- Clean ------------------------------------------
%Clean
%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} \
	-ALD_Ver=%{ALD_Ver} -RpmMovePath=%{DestDir} -tar_arg=bzip2
%endif  # have_auto_local

# ------------------- Files ------------------------------------------
%Files
%{_sysconfdir}
%{_bindir}/busybox
%{_datadir}/udhcpc
%{docdir}/AUTHORS
%{docdir}/LICENSE
%{docdir}/README

%Files env
/usr%{_bindir}/env

%Files doc
%{docdir}/html
